<template>

  <!-- 主体部分 -->
  <div class="xl:w-screen-xl m-auto py-4 mt-12 px-4 sm:px-0 sm:mt-20">
    <el-page-header :icon="ArrowLeft" @back="goBack">
      <template #content>
        <span class="text-large font-600"> {{ page.title }} </span>
      </template>
      <el-row :gutter="24" id="container" class="clearfix">
        <el-col v-for="(item,index) in list" :key="index" :span="6" :xs="24" class="left mb-8">
          <el-card :body-style="{ padding: '0px' }" class=" hover:bg-gray-50 cursor-pointer" shadow="hover" @click="navigateTo(`/detail/${item.articleId}.html`)">
            <el-image
                :src="item.image"
                fit="cover"
                :lazy="true" class="w-full md:h-[166px] h-[199px] cursor-pointer bg-gray-50"/>
            <div class="flex-1 px-4 py-5 sm:p-6 !p-4">
              <div class="text-gray-700 dark:text-white text-base font-semibold  flex flex-col gap-1.5">
                <div class="text-xl cursor-pointer items-center line-clamp-1">
                  {{ item.title }}
                </div>
              </div>
              <div class="flex items-center gap-1.5 py-2 text-gray-500 justify-between">
                <div class="text-gray-500 line-clamp-2">{{ item.comments }}</div>
              </div>
              <div class="button-group flex justify-between items-center mt-3 text-sm">
                <el-space class="flex items-end">
                  <div class="text-gray-400 gap-1 flex items-center"><el-icon><View /></el-icon><span>{{ getViews(item) }}</span></div>
                </el-space>
                <div class="text-gray-400">
                  <el-avatar v-if="item.avatar" size="small" :src="`${item.avatar}`" />
                  {{ dayjs(item.createTime).format('YYYY.MM.DD') }}
                </div>
              </div>
            </div>
          </el-card>
        </el-col>
      </el-row>
    </el-page-header>

    <Pagination :total="total" @done="search" />
  </div>

</template>
<script setup lang="ts">
import Banner from "@/components/Banner.vue";
import { ArrowLeft,View, Search } from '@element-plus/icons-vue'
import { ElNotification as notify } from 'element-plus'
import {useConfigInfo, useLayout, usePage} from "~/composables/configState";
import type {CmsNavigation} from "~/api/cms/cmsNavigation/model";
import type {CmsArticle, CmsArticleParam} from "~/api/cms/cmsArticle/model";
import type { ComponentSize } from 'element-plus'
import { ElNotification } from 'element-plus'
import type { TabsPaneContext } from 'element-plus'
import { h } from 'vue'
import dayjs from "dayjs";
import {detail, getNavIdByParamsId, navTo, paramsId} from "~/utils/common";
import Left from "~/components/Left.vue";
import {getCmsNavigation, listCmsNavigation} from "~/api/cms/cmsNavigation";
import {pageCmsArticle} from "~/api/cms/cmsArticle";

const route = useRoute();
const router = useRouter();
const navId = ref();
// 页面信息
const list = ref<CmsArticle[]>([]);
const i18n = useI18n();
const category = ref<CmsNavigation[]>([]);
const total = ref(0);
const activeName = ref('2839');

// 获取状态
const page = usePage();
const layout = useLayout();

// 搜索表单
const where = reactive<CmsArticleParam>({
  keywords: '',
  page: 1,
  limit: 12,
  status: 0,
  recommend: 1,
  order: 'desc',
  sort: 'actualViews',
  parentId: undefined,
  categoryId: undefined,
  lang: i18n.locale.value
});

const goBack = () => {
  router.back();
}

// 加载页面数据
const reload = async () => {
  await getCmsNavigation(navId.value).then(data => {
    page.value = data;
    layout.value.banner = data.banner;

    // seo
    useSeoMeta({
      description: data.comments || data.title,
      keywords: data.title,
      titleTemplate: `${data?.title}` + ' - %s',
    })

    // 二级栏目分类
    listCmsNavigation({
      parentId: data.parentId == 0 ? data.navigationId : data.parentId
    }).then(navigation => {
      category.value = navigation;
      // 加载文章列表
      if(data.parentId == 0 && category.value.length > 0){
        where.parentId = page.value.navigationId;
      }else {
        where.categoryId = page.value.navigationId;
      }
      pageCmsArticle(where).then(response => {
        if(response){
          total.value = response.count;
          list.value = response.list;
        }
      })
    })
  }).catch(() => {})

}

/**
 * 搜索
 * @param data
 */
const search = (data: CmsArticleParam) => {
  where.page = data.page;
  reload();
}

const handleClick = (tab: TabsPaneContext, event: Event) => {
  console.log(tab, event)
}
const value = ref('')
const options = [
  {
    value: 'Option1',
    label: 'Option1',
  },
  {
    value: 'Option2',
    label: 'Option2',
  },
  {
    value: 'Option3',
    label: 'Option3',
  },
  {
    value: 'Option4',
    label: 'Option4',
  },
  {
    value: 'Option5',
    label: 'Option5',
  },
]

watch(
    () => route.params.id,
    (id) => {
      navId.value = getNavIdByParamsId(id);
      reload();
    },
    { immediate: true }
);
</script>
<style lang="scss">
.right .content img{
  width: auto !important;
}
.demo-tabs > .el-tabs__content {
  padding: 32px;
  color: #6b778c;
  font-size: 32px;
  font-weight: 600;
}
</style>
